Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administration/3.4/Properties/AssemblyInfo.frame
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administration/3.4/Properties/AssemblyInfo.frame	(revision 6381)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Administration/3.4/Properties/AssemblyInfo.frame	(revision 6381)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Clients.Hive.Administration")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("HEAL")]
+[assembly: AssemblyProduct("HeuristicLab")]
+[assembly: AssemblyCopyright("(c) 2002-2011 HEAL")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("7c14407e-6980-465b-ba3a-4a916d48989b")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("3.3.0.0")]
+[assembly: AssemblyFileVersion("3.3.0.$WCREV$")]
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/HeuristicLab.Clients.Hive.ExperimentManager-3.4.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/HeuristicLab.Clients.Hive.ExperimentManager-3.4.csproj	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/HeuristicLab.Clients.Hive.ExperimentManager-3.4.csproj	(revision 6381)
@@ -151,9 +151,9 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Views\HiveExperimentListView.cs">
+    <Compile Include="Views\RefreshableHiveExperimentListView.cs">
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="Views\HiveExperimentListView.Designer.cs">
-      <DependentUpon>HiveExperimentListView.cs</DependentUpon>
+    <Compile Include="Views\RefreshableHiveExperimentListView.Designer.cs">
+      <DependentUpon>RefreshableHiveExperimentListView.cs</DependentUpon>
     </Compile>
     <Compile Include="Views\HiveExperimentManagerView.cs">
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/HiveExperimentManagerView.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/HiveExperimentManagerView.Designer.cs	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/HiveExperimentManagerView.Designer.cs	(revision 6381)
@@ -46,5 +46,5 @@
     private void InitializeComponent() {
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(HiveExperimentManagerView));
-      this.hiveExperimentListView = new HiveExperimentListView();
+      this.hiveExperimentListView = new RefreshableHiveExperimentListView();
       this.refreshButton = new System.Windows.Forms.Button();
       this.SuspendLayout();
@@ -86,5 +86,5 @@
     #endregion
 
-    private HiveExperimentListView hiveExperimentListView;
+    private RefreshableHiveExperimentListView hiveExperimentListView;
     private System.Windows.Forms.Button refreshButton;
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentListView.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentListView.Designer.cs	(revision 6381)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentListView.Designer.cs	(revision 6381)
@@ -0,0 +1,32 @@
+﻿namespace HeuristicLab.Clients.Hive.ExperimentManager.Views {
+  partial class RefreshableHiveExperimentListView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentListView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentListView.cs	(revision 6381)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentListView.cs	(revision 6381)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Clients.Hive.ExperimentManager.Views {
+  [View("HiveExperimentList View")]
+  [Content(typeof(ItemCollection<RefreshableHiveExperiment>), false)]
+  public partial class RefreshableHiveExperimentListView : ItemCollectionView<RefreshableHiveExperiment> {
+
+    public RefreshableHiveExperimentListView() {
+      InitializeComponent();
+    }
+
+    protected override RefreshableHiveExperiment CreateItem() {
+      return new RefreshableHiveExperiment();
+    }
+
+    protected override void removeButton_Click(object sender, EventArgs e) {
+      DialogResult result = MessageBox.Show("This action will permanently delete this experiment (also on the hive server). Continue?", "Delete Experiment", MessageBoxButtons.OKCancel);
+      if (result == DialogResult.OK) {
+        base.removeButton_Click(sender, e);
+      }
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentView.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentView.Designer.cs	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentView.Designer.cs	(revision 6381)
@@ -50,4 +50,5 @@
       this.tabControl = new System.Windows.Forms.TabControl();
       this.jobsTabPage = new System.Windows.Forms.TabPage();
+      this.jobsTreeView = new HeuristicLab.Clients.Hive.Views.ExperimentManager.HiveJobItemTreeView();
       this.logTabPage = new System.Windows.Forms.TabPage();
       this.logView = new HeuristicLab.Core.Views.LogView();
@@ -73,5 +74,5 @@
       this.calculatingLabel = new System.Windows.Forms.Label();
       this.jobsLabel = new System.Windows.Forms.Label();
-      this.jobsTreeView = new HeuristicLab.Clients.Hive.Views.ExperimentManager.HiveJobItemTreeView();
+      this.isPrivilegedCheckBox = new System.Windows.Forms.CheckBox();
       this.tabControl.SuspendLayout();
       this.jobsTabPage.SuspendLayout();
@@ -90,5 +91,5 @@
       this.tabControl.Name = "tabControl";
       this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(821, 520);
+      this.tabControl.Size = new System.Drawing.Size(717, 452);
       this.tabControl.TabIndex = 4;
       // 
@@ -98,8 +99,25 @@
       this.jobsTabPage.Location = new System.Drawing.Point(4, 22);
       this.jobsTabPage.Name = "jobsTabPage";
-      this.jobsTabPage.Size = new System.Drawing.Size(813, 494);
+      this.jobsTabPage.Size = new System.Drawing.Size(709, 426);
       this.jobsTabPage.TabIndex = 5;
       this.jobsTabPage.Text = "Jobs";
       this.jobsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // jobsTreeView
+      // 
+      this.jobsTreeView.AllowDrop = true;
+      this.jobsTreeView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.jobsTreeView.Caption = "ItemTree View";
+      this.jobsTreeView.Content = null;
+      this.jobsTreeView.Location = new System.Drawing.Point(2, 3);
+      this.jobsTreeView.Name = "jobsTreeView";
+      this.jobsTreeView.ReadOnly = false;
+      this.jobsTreeView.Size = new System.Drawing.Size(704, 420);
+      this.jobsTreeView.TabIndex = 0;
+      this.jobsTreeView.DragDrop += new System.Windows.Forms.DragEventHandler(this.jobsTreeView_DragDrop);
+      this.jobsTreeView.DragEnter += new System.Windows.Forms.DragEventHandler(this.jobsTreeView_DragEnter);
+      this.jobsTreeView.DragOver += new System.Windows.Forms.DragEventHandler(this.jobsTreeView_DragOver);
       // 
       // logTabPage
@@ -128,5 +146,5 @@
       this.startButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.startButton.Image = ((System.Drawing.Image)(resources.GetObject("startButton.Image")));
-      this.startButton.Location = new System.Drawing.Point(0, 604);
+      this.startButton.Location = new System.Drawing.Point(0, 536);
       this.startButton.Name = "startButton";
       this.startButton.Size = new System.Drawing.Size(24, 24);
@@ -140,5 +158,5 @@
       this.stopButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.stopButton.Image = ((System.Drawing.Image)(resources.GetObject("stopButton.Image")));
-      this.stopButton.Location = new System.Drawing.Point(60, 604);
+      this.stopButton.Location = new System.Drawing.Point(60, 536);
       this.stopButton.Name = "stopButton";
       this.stopButton.Size = new System.Drawing.Size(24, 24);
@@ -153,5 +171,5 @@
       this.resetButton.Enabled = false;
       this.resetButton.Image = ((System.Drawing.Image)(resources.GetObject("resetButton.Image")));
-      this.resetButton.Location = new System.Drawing.Point(90, 604);
+      this.resetButton.Location = new System.Drawing.Point(90, 536);
       this.resetButton.Name = "resetButton";
       this.resetButton.Size = new System.Drawing.Size(24, 24);
@@ -165,5 +183,5 @@
       this.executionTimeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.executionTimeLabel.AutoSize = true;
-      this.executionTimeLabel.Location = new System.Drawing.Point(595, 611);
+      this.executionTimeLabel.Location = new System.Drawing.Point(491, 543);
       this.executionTimeLabel.Name = "executionTimeLabel";
       this.executionTimeLabel.Size = new System.Drawing.Size(83, 13);
@@ -174,5 +192,5 @@
       // 
       this.executionTimeTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.executionTimeTextBox.Location = new System.Drawing.Point(684, 608);
+      this.executionTimeTextBox.Location = new System.Drawing.Point(580, 540);
       this.executionTimeTextBox.Name = "executionTimeTextBox";
       this.executionTimeTextBox.ReadOnly = true;
@@ -185,5 +203,5 @@
       this.pauseButton.Enabled = false;
       this.pauseButton.Image = ((System.Drawing.Image)(resources.GetObject("pauseButton.Image")));
-      this.pauseButton.Location = new System.Drawing.Point(30, 604);
+      this.pauseButton.Location = new System.Drawing.Point(30, 536);
       this.pauseButton.Name = "pauseButton";
       this.pauseButton.Size = new System.Drawing.Size(24, 24);
@@ -208,5 +226,5 @@
       this.resourceNamesTextBox.Location = new System.Drawing.Point(73, 53);
       this.resourceNamesTextBox.Name = "resourceNamesTextBox";
-      this.resourceNamesTextBox.Size = new System.Drawing.Size(494, 20);
+      this.resourceNamesTextBox.Size = new System.Drawing.Size(304, 20);
       this.resourceNamesTextBox.TabIndex = 14;
       this.resourceNamesTextBox.Validated += new System.EventHandler(this.resourceNamesTextBox_Validated);
@@ -216,5 +234,5 @@
       this.useLocalPluginsCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.useLocalPluginsCheckBox.AutoSize = true;
-      this.useLocalPluginsCheckBox.Location = new System.Drawing.Point(573, 56);
+      this.useLocalPluginsCheckBox.Location = new System.Drawing.Point(469, 56);
       this.useLocalPluginsCheckBox.Name = "useLocalPluginsCheckBox";
       this.useLocalPluginsCheckBox.Size = new System.Drawing.Size(105, 17);
@@ -239,5 +257,5 @@
       this.nameTextBox.Location = new System.Drawing.Point(73, 27);
       this.nameTextBox.Name = "nameTextBox";
-      this.nameTextBox.Size = new System.Drawing.Size(605, 20);
+      this.nameTextBox.Size = new System.Drawing.Size(501, 20);
       this.nameTextBox.TabIndex = 21;
       this.nameTextBox.Validated += new System.EventHandler(this.nameTextBox_Validated);
@@ -274,5 +292,5 @@
       this.infoGroupBox.Controls.Add(this.calculatingLabel);
       this.infoGroupBox.Controls.Add(this.jobsLabel);
-      this.infoGroupBox.Location = new System.Drawing.Point(684, 5);
+      this.infoGroupBox.Location = new System.Drawing.Point(580, 5);
       this.infoGroupBox.Name = "infoGroupBox";
       this.infoGroupBox.Size = new System.Drawing.Size(133, 89);
@@ -335,20 +353,16 @@
       this.jobsLabel.Text = "Jobs:";
       // 
-      // jobsTreeView
-      // 
-      this.jobsTreeView.AllowDrop = true;
-      this.jobsTreeView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.jobsTreeView.Caption = "ItemTree View";
-      this.jobsTreeView.Content = null;
-      this.jobsTreeView.Location = new System.Drawing.Point(2, 3);
-      this.jobsTreeView.Name = "jobsTreeView";
-      this.jobsTreeView.ReadOnly = false;
-      this.jobsTreeView.Size = new System.Drawing.Size(808, 488);
-      this.jobsTreeView.TabIndex = 0;
-      this.jobsTreeView.DragDrop += new System.Windows.Forms.DragEventHandler(this.jobsTreeView_DragDrop);
-      this.jobsTreeView.DragEnter += new System.Windows.Forms.DragEventHandler(this.jobsTreeView_DragEnter);
-      this.jobsTreeView.DragOver += new System.Windows.Forms.DragEventHandler(this.jobsTreeView_DragOver);
+      // isPrivilegedCheckBox
+      // 
+      this.isPrivilegedCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.isPrivilegedCheckBox.AutoSize = true;
+      this.isPrivilegedCheckBox.Location = new System.Drawing.Point(383, 55);
+      this.isPrivilegedCheckBox.Name = "isPrivilegedCheckBox";
+      this.isPrivilegedCheckBox.Size = new System.Drawing.Size(80, 17);
+      this.isPrivilegedCheckBox.TabIndex = 26;
+      this.isPrivilegedCheckBox.Text = "IsPrivileged";
+      this.toolTip.SetToolTip(this.isPrivilegedCheckBox, "If checked, the job will be executed in a privileged sandbox on the slave.");
+      this.isPrivilegedCheckBox.UseVisualStyleBackColor = true;
+      this.isPrivilegedCheckBox.CheckedChanged += new System.EventHandler(this.isPrivilegedCheckBox_CheckedChanged);
       // 
       // RefreshableHiveExperimentView
@@ -356,4 +370,5 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.isPrivilegedCheckBox);
       this.Controls.Add(this.infoGroupBox);
       this.Controls.Add(this.refreshAutomaticallyCheckBox);
@@ -372,5 +387,5 @@
       this.Controls.Add(this.resetButton);
       this.Name = "RefreshableHiveExperimentView";
-      this.Size = new System.Drawing.Size(821, 628);
+      this.Size = new System.Drawing.Size(717, 560);
       this.tabControl.ResumeLayout(false);
       this.jobsTabPage.ResumeLayout(false);
@@ -410,4 +425,5 @@
     private System.Windows.Forms.Label calculatingLabel;
     private System.Windows.Forms.Label jobsLabel;
+    private System.Windows.Forms.CheckBox isPrivilegedCheckBox;
 
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentView.cs	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.ExperimentManager/3.4/Views/RefreshableHiveExperimentView.cs	(revision 6381)
@@ -103,7 +103,7 @@
         resourceNamesTextBox.Text = string.Empty;
         useLocalPluginsCheckBox.Checked = false;
+        isPrivilegedCheckBox.Checked = false;
         logView.Content = null;
-        //includeJobsCheckBox.Checked = false;
-        refreshAutomaticallyCheckBox.Checked = false;
+        refreshAutomaticallyCheckBox.Checked = false;        
         logView.Content = null;
       } else {
@@ -112,5 +112,5 @@
         resourceNamesTextBox.Text = Content.HiveExperiment.ResourceNames;
         useLocalPluginsCheckBox.Checked = Content.HiveExperiment.UseLocalPlugins;
-        //includeJobsCheckBox.Checked = Content.IncludeJobs;
+        isPrivilegedCheckBox.Checked = Content.HiveExperiment.IsPrivileged;
         refreshAutomaticallyCheckBox.Checked = Content.RefreshAutomatically;
         logView.Content = Content.Log;
@@ -138,8 +138,10 @@
         this.jobsTreeView.ReadOnly = !Content.IsControllable || Content.HiveExperiment.ExecutionState != ExecutionState.Prepared || alreadyUploaded;
 
+        this.isPrivilegedCheckBox.Enabled = Content.IsControllable && !(Content.HiveExperiment.ExecutionState != ExecutionState.Prepared || alreadyUploaded); // TODO: check if user has the rights to do this
         this.useLocalPluginsCheckBox.Enabled = Content.IsControllable && !(Content.HiveExperiment.ExecutionState != ExecutionState.Prepared || alreadyUploaded);
         this.refreshAutomaticallyCheckBox.Enabled = Content.IsControllable && alreadyUploaded && jobsLoaded && Content.HiveExperiment.ExecutionState == ExecutionState.Started;
         this.refreshButton.Enabled = Content.IsControllable && alreadyUploaded;
         this.Locked = !Content.IsControllable || Content.HiveExperiment.ExecutionState == ExecutionState.Started;
+
       }
       SetEnabledStateOfExecutableButtons();
@@ -296,4 +298,8 @@
     private void useLocalPluginsCheckBox_CheckedChanged(object sender, EventArgs e) {
       if (Content != null) Content.HiveExperiment.UseLocalPlugins = useLocalPluginsCheckBox.Checked;
+    }
+
+    private void isPrivilegedCheckBox_CheckedChanged(object sender, EventArgs e) {
+      if (Content != null) Content.HiveExperiment.IsPrivileged = isPrivilegedCheckBox.Checked;
     }
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Core.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Core.cs	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Core.cs	(revision 6381)
@@ -228,5 +228,5 @@
       Guid jobId = (Guid)jobIdObj;
       Job job = null;
-      bool usedCoresIncremented = false;
+      int usedCores = 0;
       try {
         job = wcfService.GetJob(jobId);
@@ -234,5 +234,5 @@
         if (ConfigManager.Instance.GetFreeCores() < job.CoresNeeded) throw new OutOfCoresException();
         if (ConfigManager.GetFreeMemory() < job.MemoryNeeded) throw new OutOfMemoryException();
-        SlaveStatusInfo.IncrementUsedCores(job.CoresNeeded); usedCoresIncremented = true;
+        SlaveStatusInfo.IncrementUsedCores(job.CoresNeeded); usedCores = job.CoresNeeded;
         JobData jobData = wcfService.GetJobData(jobId);
         if (jobData == null) throw new JobDataNotFoundException(jobId);
@@ -242,13 +242,13 @@
       }
       catch (JobNotFoundException) {
-        if (usedCoresIncremented) SlaveStatusInfo.DecrementUsedCores(job.CoresNeeded);
+        SlaveStatusInfo.DecrementUsedCores(usedCores);
         throw;
       }
       catch (JobDataNotFoundException) {
-        SlaveStatusInfo.DecrementUsedCores(job.CoresNeeded);
+        SlaveStatusInfo.DecrementUsedCores(usedCores);
         throw;
       }
       catch (JobAlreadyRunningException) {
-        SlaveStatusInfo.DecrementUsedCores(job.CoresNeeded);
+        SlaveStatusInfo.DecrementUsedCores(usedCores);
         throw;
       }
@@ -261,6 +261,7 @@
         throw;
       }
-      catch (Exception) {
-        if (usedCoresIncremented) SlaveStatusInfo.DecrementUsedCores(job.CoresNeeded);
+      catch (Exception e) {
+        SlaveStatusInfo.DecrementUsedCores(usedCores);
+        wcfService.UpdateJobState(jobId, JobState.Waiting, e.ToString()); // unknown internal error - report and set waiting again
         throw;
       }
@@ -372,5 +373,5 @@
         job.ExecutionTime = slaveJob.ExecutionTime;
         if (jobData != null) {
-          wcfService.UpdateJobData(job, jobData, configManager.GetClientInfo().Id, JobState.Failed);
+          wcfService.UpdateJobData(job, jobData, configManager.GetClientInfo().Id, JobState.Failed, exception.ToString());
         } else {
           wcfService.UpdateJobState(job.Id, JobState.Failed, exception.ToString());
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Executor.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Executor.cs	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Executor.cs	(revision 6381)
@@ -154,4 +154,5 @@
     #region Job Events
     private void Job_JobFailed(object sender, EventArgs e) {
+      IsStopping = true;
       EventArgs<Exception> ex = (EventArgs<Exception>)e;
       currentException = ex.Value;
@@ -161,4 +162,5 @@
 
     private void Job_JobStopped(object sender, EventArgs e) {
+      IsStopping = true;
       if (wasJobAborted)
         pauseStopSem.Release();
@@ -168,4 +170,5 @@
 
     private void Job_JobPaused(object sender, EventArgs e) {
+      IsPausing = true;
       pauseStopSem.Release();
       executorQueue.AddMessage(ExecutorMessageType.JobPaused);
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Manager/JobManager.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Manager/JobManager.cs	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/Manager/JobManager.cs	(revision 6381)
@@ -86,6 +86,6 @@
         }
         catch (Exception) {
+          RemoveSlaveJob(job.Id, slaveJob); // clean up and rethrow
           slaveJob.DisposeAppDomain();
-          RemoveSlaveJob(job.Id, slaveJob); // clean up and rethrow
           throw;
         }
@@ -268,5 +268,5 @@
         if (jobData == null) throw new SerializationException();
       }
-      catch { }
+      catch { /* jobData will be null */ }
       SlaveStatusInfo.IncrementJobsFailed();
       OnJobFailed(slaveJob, jobData, e.Value2);
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/WcfService.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/WcfService.cs	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.4/WcfService.cs	(revision 6381)
@@ -101,10 +101,10 @@
     /// Uploads the jobData and sets a new jobState (while correctly setting Transferring state)
     /// </summary>
-    public void UpdateJobData(Job job, JobData jobData, Guid slaveId, JobState state) {
+    public void UpdateJobData(Job job, JobData jobData, Guid slaveId, JobState state, string exception = "") {
       CallHiveService(service => {
         service.UpdateJob(job);
         job = service.UpdateJobState(job.Id, JobState.Transferring, slaveId, null, null);
         service.UpdateJobData(job, jobData);
-        service.UpdateJobState(job.Id, state, slaveId, null, null);
+        service.UpdateJobState(job.Id, state, slaveId, null, exception);
       });
     }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLab.Clients.Hive.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLab.Clients.Hive.Views-3.4.csproj	(revision 6373)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.4/HeuristicLab.Clients.Hive.Views-3.4.csproj	(revision 6381)
@@ -125,9 +125,9 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="HiveJobs\ControllableHiveJobView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="HiveJobs\ControllableHiveJobView.designer.cs">
-      <DependentUpon>ControllableHiveJobView.cs</DependentUpon>
+    <Compile Include="HiveJobs\OptimizerHiveJobView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="HiveJobs\OptimizerHiveJobView.designer.cs">
+      <DependentUpon>OptimizerHiveJobView.cs</DependentUpon>
     </Compile>
     <Compile Include="HiveItemView.cs">
@@ -220,6 +220,6 @@
   </ItemGroup>
   <ItemGroup>
-    <EmbeddedResource Include="HiveJobs\ControllableHiveJobView.resx">
-      <DependentUpon>ControllableHiveJobView.cs</DependentUpon>
+    <EmbeddedResource Include="HiveJobs\OptimizerHiveJobView.resx">
+      <DependentUpon>OptimizerHiveJobView.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="HiveJobs\HiveJobView.resx">
